Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/requestcycle/Context.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/requestcycle/Context.java	(revision 2584)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/requestcycle/Context.java	(revision 2584)
@@ -0,0 +1,130 @@
+/*
+ * FCKeditor - The text editor for Internet - http://www.fckeditor.net
+ * Copyright (C) 2003-2008 Frederico Caldeira Knabben
+ * 
+ * == BEGIN LICENSE ==
+ * 
+ * Licensed under the terms of any of the following licenses at your
+ * choice:
+ * 
+ *  - GNU General Public License Version 2 or later (the "GPL")
+ *    http://www.gnu.org/licenses/gpl.html
+ * 
+ *  - GNU Lesser General Public License Version 2.1 or later (the "LGPL")
+ *    http://www.gnu.org/licenses/lgpl.html
+ * 
+ *  - Mozilla Public License Version 1.1 or later (the "MPL")
+ *    http://www.mozilla.org/MPL/MPL-1.1.html
+ * 
+ * == END LICENSE ==
+ */
+package net.fckeditor.requestcycle;
+
+import javax.servlet.http.HttpServletRequest;
+
+import net.fckeditor.handlers.CommandHandler;
+import net.fckeditor.handlers.ConnectorHandler;
+import net.fckeditor.handlers.ResourceType;
+import net.fckeditor.tool.Utils;
+
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+
+/**
+ * Holds basic parameters and associated methods for each request.
+ *
+ * @version $Id$
+ */
+public class Context {
+	private static final Logger logger = LoggerFactory.getLogger(Context.class);
+	
+	private String typeStr;
+	private String commandStr;
+	private String currentFolderStr;
+	
+	protected Context(final HttpServletRequest request) {
+		commandStr = request.getParameter("Command");
+		typeStr = request.getParameter("Type");
+		currentFolderStr = request.getParameter("CurrentFolder");
+		
+		// checks to meet specs in http://docs.fckeditor.net/FCKeditor_2.x/Developers_Guide/Server_Side_Integration#File_Browser_Requests
+		if (currentFolderStr != null && !currentFolderStr.startsWith("/"))
+			currentFolderStr = "/".concat(currentFolderStr);
+	}
+	
+	public boolean checkQuickUpload() {
+		if (Utils.isEmpty(commandStr) && Utils.isEmpty(currentFolderStr)) {
+			commandStr = "QuickUpload";
+			currentFolderStr = "/";
+			return true;
+		}
+		return false;
+	}
+	
+	/**
+	 * @return the typeStr
+	 */
+	public String getTypeStr() {
+		return typeStr;
+	}
+	
+	public ResourceType getDefaultResourceType() {
+		return ResourceType.getDefaultResourceType(typeStr);
+	}
+	
+	/**
+	 * @return the commandStr
+	 */
+	public String getCommandStr() {
+		return commandStr;
+	}
+	
+	public CommandHandler getCommand() {
+		return CommandHandler.valueOf(commandStr);
+	}
+	
+	/**
+	 * @return the currentFolderStr
+	 */
+	public String getCurrentFolderStr() {
+		return currentFolderStr;
+	}
+	
+	public void logBaseParameters() {
+		logger.debug("Parameter Command: {}", commandStr);
+		logger.debug("Parameter Type: {}", typeStr);
+		logger.debug("Parameter CurrentFolder: {}", currentFolderStr);
+	}
+	
+	/**
+	 * @return
+	 */
+	public String buildCurrentTypeDir() {
+		StringBuffer sb = new StringBuffer();
+		if (Utils.isNotEmpty(typeStr))
+			sb.append(getDefaultResourceType().getPath());
+		if (Utils.isNotEmpty(currentFolderStr))
+			sb.append(currentFolderStr);
+		if (!sb.toString().endsWith("/"))
+			sb.append("/");
+		return sb.toString();
+	}
+	
+	public String buildUrl(final String baseDir) {
+    	StringBuffer sb = new StringBuffer();
+    	HttpServletRequest request = ThreadLocalData.getServletRequest();
+
+		if (Utils.isNotEmpty(ConnectorHandler.getBaseUrl())) {
+			sb.append(ConnectorHandler.getBaseUrl());
+		} else if (ConnectorHandler.isFullUrl()) {
+    		String address = request.getRequestURL().toString();
+    		sb.append(address.substring(0, address.indexOf('/', 8)));
+    	}
+    	    	
+    	sb.append(baseDir);
+    	String currentTypeDir = buildCurrentTypeDir();
+    	if (!currentTypeDir.equals("/"))
+    		sb.append(buildCurrentTypeDir());
+    	return sb.toString();
+	}
+}
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/requestcycle/ThreadLocalData.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/requestcycle/ThreadLocalData.java	(revision 2584)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/requestcycle/ThreadLocalData.java	(revision 2584)
@@ -0,0 +1,61 @@
+/*
+ * FCKeditor - The text editor for Internet - http://www.fckeditor.net
+ * Copyright (C) 2003-2008 Frederico Caldeira Knabben
+ * 
+ * == BEGIN LICENSE ==
+ * 
+ * Licensed under the terms of any of the following licenses at your
+ * choice:
+ * 
+ *  - GNU General Public License Version 2 or later (the "GPL")
+ *    http://www.gnu.org/licenses/gpl.html
+ * 
+ *  - GNU Lesser General Public License Version 2.1 or later (the "LGPL")
+ *    http://www.gnu.org/licenses/lgpl.html
+ * 
+ *  - Mozilla Public License Version 1.1 or later (the "MPL")
+ *    http://www.mozilla.org/MPL/MPL-1.1.html
+ * 
+ * == END LICENSE ==
+ */
+package net.fckeditor.requestcycle;
+
+import javax.servlet.http.HttpServletRequest;
+
+/**
+ * Container for {@link ThreadLocal}s.<br>
+ *
+ * @version $Id$
+ */
+public class ThreadLocalData {
+	private static ThreadLocal<HttpServletRequest> servletRequest = null;
+	private static ThreadLocal<Context> context = null;
+	
+	public static void beginRequest(final HttpServletRequest servletRequest) {
+		if (servletRequest == null)
+			throw new IllegalArgumentException();
+		if (ThreadLocalData.servletRequest == null)
+			ThreadLocalData.servletRequest = new ThreadLocal<HttpServletRequest>();
+		ThreadLocalData.servletRequest.set(servletRequest);
+		if (ThreadLocalData.context == null)
+			ThreadLocalData.context = new ThreadLocal<Context>();
+		ThreadLocalData.context.set(new Context(servletRequest));
+	}
+	
+	public static HttpServletRequest getServletRequest() {
+		return (servletRequest == null) ? null : servletRequest.get();
+	}
+	
+	 public static Context getContext() {
+		 return (context == null) ? null : context.get();
+	 }
+	
+	/**
+	 * Clear the ThreadLocals.<br>
+	 * <b>Important: To prevent memory leaks we have to make sure that this method is calling at the end of each request cycle!!!</b>
+	 */
+	public static void endRequest() {
+		servletRequest = null;
+		context = null;
+	}
+}
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/requestcycle/UserAction.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/requestcycle/UserAction.java	(revision 2578)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/requestcycle/UserAction.java	(revision 2584)
@@ -24,13 +24,18 @@
 
 
+
 /**
  * An interface which provides the authorization of server-side commands.<br />
  * The commands are:
  * <ul>
- * <li>{@link #isEnabledForFileBrowsing(HttpServletRequest)}: Enables the user
+ * <li>{@link #isEnabledForFileBrowsing()}: Enables the user
  * to browse/select files.</li>
- * <li>{@link #isEnabledForFileUpload(HttpServletRequest)}: Enables the user
+ * <li>{@link #isEnabledForFileUpload()}: Enables the user
  * to upload files.</li>
+ * <li>{@link #isEnabledForFolderCreation()} Enables the user
+ * to create folders.</li>
  * </ul>
+ * <strong>If your implementation needs {@link HttpServletRequest} e.g. to get a
+ * session variable, you can get it by calling {@link ThreadLocalData#getServletRequest()}.</strong>
  * 
  * @version $Id$
@@ -40,28 +45,26 @@
 	/**
 	 * Authenticates/enables the current user for uploading files.<br />
-	 * If the implementation doesn't bother you, just return <code>true</code>.
 	 * 
-	 * @param request
-	 *            Servlet request from user
 	 * @return <code>true</code> if user can upload to the server, or
 	 *         <code>false</code>
 	 */
-	public boolean isEnabledForFileUpload(final HttpServletRequest request);
+	public boolean isEnabledForFileUpload();
 
 	/**
 	 * Authenticates/enables the current user for browsing files.<br />
-	 * If the implementation doesn't bother you, just return <code>true</code>.
 	 * 
-	 * @param request
-	 *            Servlet request from user
 	 * @return <code>true</code> if user can browse the server, or
 	 *         <code>false</code>
 	 */
-	public boolean isEnabledForFileBrowsing(final HttpServletRequest request);
+	public boolean isEnabledForFileBrowsing();
 	
+
 	/**
-	 * TODO document me!
+	 * Authenticates/enables the current user to create folders.<br />
+	 * 
+	 * @return <code>true</code> if user can create folders on the server, or
+	 *         <code>false</code>
 	 */
-	public boolean isEnabledForFolderCreation(final HttpServletRequest request);
+	public boolean isEnabledForFolderCreation();
 
 }
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/requestcycle/UserPathBuilder.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/requestcycle/UserPathBuilder.java	(revision 2578)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/requestcycle/UserPathBuilder.java	(revision 2584)
@@ -44,10 +44,18 @@
 	 * <li>The path has to be within the context.</li>
 	 * </ul>
+	 * <strong>If your implementation needs {@link HttpServletRequest} e.g. to get a
+	 * session variable, you can get it by calling {@link ThreadLocalData#getServletRequest()}. </strong>
 	 * 
 	 * @param request
 	 * @return <code>UserFilesPath</code> for the current user.
 	 */
-	public String getUserFilesPath(final HttpServletRequest request);
+	public String getUserFilesPath();
 	
+	/**
+	 * Path needed to map resources to paths outside context of your webapp.
+	 * If the implementation don't bother you, just return <code>null</code>.
+	 * 
+	 * @return
+	 */
 	public String getLocalUserFilesPath();
 }
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/requestcycle/impl/ContextPathBuilder.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/requestcycle/impl/ContextPathBuilder.java	(revision 2578)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/requestcycle/impl/ContextPathBuilder.java	(revision 2584)
@@ -21,7 +21,6 @@
 package net.fckeditor.requestcycle.impl;
 
-import javax.servlet.http.HttpServletRequest;
-
 import net.fckeditor.handlers.ConnectorHandler;
+import net.fckeditor.requestcycle.ThreadLocalData;
 import net.fckeditor.requestcycle.UserPathBuilder;
 
@@ -35,16 +34,13 @@
 public class ContextPathBuilder implements UserPathBuilder {
 
-	/*
-	 * (non-Javadoc)
-	 * 
-	 * @see net.fckeditor.requestcycle.UserPathBuilder#getUserFilesPath(javax.servlet.http.HttpServletRequest)
+	/* (non-Javadoc)
+	 * @see net.fckeditor.requestcycle.UserPathBuilder#getUserFilesPath()
 	 */
-	public String getUserFilesPath(final HttpServletRequest request) {
-		return request.getContextPath()
-				+ ConnectorHandler.getDefaultUserFilesPath();
+	public String getUserFilesPath() {
+		String path = ThreadLocalData.getServletRequest().getContextPath().concat(ConnectorHandler.getDefaultUserFilesPath());
+		return path;
 	}
 	
-	/*
-	 * (non-Javadoc)
+	/* (non-Javadoc)
 	 * @see net.fckeditor.requestcycle.UserPathBuilder#getLocalUserFilesPath()
 	 */
@@ -52,4 +48,3 @@
 		return ConnectorHandler.getDefaultUserFilesPath();
 	}
-
 }
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/requestcycle/impl/DisabledUserAction.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/requestcycle/impl/DisabledUserAction.java	(revision 2584)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/requestcycle/impl/DisabledUserAction.java	(revision 2584)
@@ -0,0 +1,57 @@
+/*
+ * FCKeditor - The text editor for Internet - http://www.fckeditor.net
+ * Copyright (C) 2003-2008 Frederico Caldeira Knabben
+ * 
+ * == BEGIN LICENSE ==
+ * 
+ * Licensed under the terms of any of the following licenses at your
+ * choice:
+ * 
+ *  - GNU General Public License Version 2 or later (the "GPL")
+ *    http://www.gnu.org/licenses/gpl.html
+ * 
+ *  - GNU Lesser General Public License Version 2.1 or later (the "LGPL")
+ *    http://www.gnu.org/licenses/lgpl.html
+ * 
+ *  - Mozilla Public License Version 1.1 or later (the "MPL")
+ *    http://www.mozilla.org/MPL/MPL-1.1.html
+ * 
+ * == END LICENSE ==
+ */
+package net.fckeditor.requestcycle.impl;
+
+
+import net.fckeditor.requestcycle.UserAction;
+
+/**
+ * Standard implementation for {@link UserAction}. It always returns
+ * <code>false</code>.
+ * 
+ * @version $Id$
+ */
+public class DisabledUserAction implements UserAction {
+
+	/*
+	 * (non-Javadoc)
+	 * @see net.fckeditor.requestcycle.UserAction#isEnabledForFileBrowsing()
+	 */
+	public boolean isEnabledForFileBrowsing() {
+		return false;
+	}
+
+	/*
+	 * (non-Javadoc)
+	 * @see net.fckeditor.requestcycle.UserAction#isEnabledForFileUpload()
+	 */
+	public boolean isEnabledForFileUpload() {
+		return false;
+	}
+
+	/*
+	 * (non-Javadoc)
+	 * @see net.fckeditor.requestcycle.UserAction#isEnabledForFolderCreation()
+	 */
+	public boolean isEnabledForFolderCreation() {
+		return false;
+	}
+}
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/requestcycle/impl/EnabledUserAction.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/requestcycle/impl/EnabledUserAction.java	(revision 2584)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/requestcycle/impl/EnabledUserAction.java	(revision 2584)
@@ -0,0 +1,57 @@
+/*
+ * FCKeditor - The text editor for Internet - http://www.fckeditor.net
+ * Copyright (C) 2003-2008 Frederico Caldeira Knabben
+ * 
+ * == BEGIN LICENSE ==
+ * 
+ * Licensed under the terms of any of the following licenses at your
+ * choice:
+ * 
+ *  - GNU General Public License Version 2 or later (the "GPL")
+ *    http://www.gnu.org/licenses/gpl.html
+ * 
+ *  - GNU Lesser General Public License Version 2.1 or later (the "LGPL")
+ *    http://www.gnu.org/licenses/lgpl.html
+ * 
+ *  - Mozilla Public License Version 1.1 or later (the "MPL")
+ *    http://www.mozilla.org/MPL/MPL-1.1.html
+ * 
+ * == END LICENSE ==
+ */
+package net.fckeditor.requestcycle.impl;
+
+
+import net.fckeditor.requestcycle.UserAction;
+
+/**
+ * Standard implementation for {@link UserAction}. It always returns
+ * <code>true</code>.
+ * 
+ * @version $Id$
+ */
+public class EnabledUserAction implements UserAction {
+
+	/*
+	 * (non-Javadoc)
+	 * @see net.fckeditor.requestcycle.UserAction#isEnabledForFileBrowsing()
+	 */
+	public boolean isEnabledForFileBrowsing() {
+		return true;
+	}
+
+	/*
+	 * (non-Javadoc)
+	 * @see net.fckeditor.requestcycle.UserAction#isEnabledForFileUpload()
+	 */
+	public boolean isEnabledForFileUpload() {
+		return true;
+	}
+
+	/*
+	 * (non-Javadoc)
+	 * @see net.fckeditor.requestcycle.UserAction#isEnabledForFolderCreation()
+	 */
+	public boolean isEnabledForFolderCreation() {
+		return true;
+	}
+}
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/requestcycle/impl/UserActionImpl.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/requestcycle/impl/UserActionImpl.java	(revision 2578)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/requestcycle/impl/UserActionImpl.java	(revision 2584)
@@ -21,5 +21,4 @@
 package net.fckeditor.requestcycle.impl;
 
-import javax.servlet.http.HttpServletRequest;
 
 import net.fckeditor.requestcycle.UserAction;
@@ -29,5 +28,5 @@
  * <code>true</code>.
  * 
- * @see TrueUserAction
+ * @see EnabledUserAction
  * @version $Id$
  */
@@ -38,5 +37,5 @@
 	 * @see net.fckeditor.requestcycle.UserAction#isEnabledForFileBrowsing(javax.servlet.http.HttpServletRequest)
 	 */
-	public boolean isEnabledForFileBrowsing(final HttpServletRequest request) {
+	public boolean isEnabledForFileBrowsing() {
 		return true;
 	}
@@ -45,5 +44,5 @@
 	 * @see net.fckeditor.requestcycle.UserAction#isEnabledForFileUpload(javax.servlet.http.HttpServletRequest)
 	 */
-	public boolean isEnabledForFileUpload(final HttpServletRequest request) {
+	public boolean isEnabledForFileUpload() {
 		return true;
 	}
@@ -53,5 +52,5 @@
 	 * @see net.fckeditor.requestcycle.UserAction#isEnabledForFolderCreation(javax.servlet.http.HttpServletRequest)
 	 */
-	public boolean isEnabledForFolderCreation(HttpServletRequest request) {
+	public boolean isEnabledForFolderCreation() {
 		return true;
 	}
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/response/GetResponse.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/response/GetResponse.java	(revision 2584)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/response/GetResponse.java	(revision 2584)
@@ -0,0 +1,285 @@
+/*
+ * FCKeditor - The text editor for Internet - http://www.fckeditor.net
+ * Copyright (C) 2003-2008 Frederico Caldeira Knabben
+ * 
+ * == BEGIN LICENSE ==
+ * 
+ * Licensed under the terms of any of the following licenses at your
+ * choice:
+ * 
+ *  - GNU General Public License Version 2 or later (the "GPL")
+ *    http://www.gnu.org/licenses/gpl.html
+ * 
+ *  - GNU Lesser General Public License Version 2.1 or later (the "LGPL")
+ *    http://www.gnu.org/licenses/lgpl.html
+ * 
+ *  - Mozilla Public License Version 1.1 or later (the "MPL")
+ *    http://www.mozilla.org/MPL/MPL-1.1.html
+ * 
+ * == END LICENSE ==
+ */
+package net.fckeditor.response;
+
+import java.io.StringWriter;
+import java.util.List;
+import java.util.Map;
+
+import javax.xml.parsers.DocumentBuilder;
+import javax.xml.parsers.DocumentBuilderFactory;
+import javax.xml.parsers.ParserConfigurationException;
+import javax.xml.transform.Transformer;
+import javax.xml.transform.TransformerException;
+import javax.xml.transform.TransformerFactory;
+import javax.xml.transform.dom.DOMSource;
+import javax.xml.transform.stream.StreamResult;
+
+import net.fckeditor.connector.Connector;
+import net.fckeditor.handlers.CommandHandler;
+import net.fckeditor.handlers.LocalizedPropertiesLoader;
+import net.fckeditor.handlers.ResourceType;
+import net.fckeditor.requestcycle.ThreadLocalData;
+import net.fckeditor.tool.Utils;
+
+import org.w3c.dom.Document;
+import org.w3c.dom.Element;
+
+/**
+ * Creates an XML response for every <code>GET</code> request of the Connector
+ * servlet. This class maps directly to the XML layout described <a
+ * href="http://docs.fckeditor.net/FCKeditor_2.x/Developers_Guide/Server_Side_Integration#The_Commands">here</a>.
+ *
+ * @version $Id$
+ */
+public class GetResponse {
+
+	private Document document;
+	private Element errorElement;
+	private Element foldersElement;
+	private Element filesElement;
+	
+	/** Error number OK */
+	public static final int EN_OK = 0;
+	
+	/** Error number ERROR */
+	public static final int EN_ERROR = 1;
+
+	/** Error number ALREADY EXISTS */
+	public static final int EN_ALREADY_EXISTS = 101;
+
+	/** Error number INVALID FOLDER NAME */
+	public static final int EN_INVALID_FOLDER_NAME = 102;
+
+	/** Error number SECURITY ERROR */
+	public static final int EN_SECURITY_ERROR = 103;
+
+	/** Error number UNKNOWN ERROR */
+	public static final int EN_UKNOWN = 110;
+	
+
+	/**
+	 * 
+	 * Use this constructor if want to respond a negative/error message with
+	 * custom text.
+	 * 
+	 * @param number
+	 * @param text
+	 */
+	public GetResponse(int number, String text) {
+		try {
+			DocumentBuilderFactory factory = DocumentBuilderFactory
+					.newInstance();
+			DocumentBuilder builder = factory.newDocumentBuilder();
+			document = builder.newDocument();
+		} catch (ParserConfigurationException e) {
+			throw new RuntimeException(e);
+		}
+
+		Element root = document.createElement("Connector");
+		document.appendChild(root);
+		setError(number, text);
+	}
+	
+	/**
+	 * Use this constructor if want to respond a positive message.
+	 * 
+	 * @param command
+	 * @param resourceType
+	 * @param currentFolder
+	 * @param constructedUrl
+	 */
+	public GetResponse(CommandHandler command, ResourceType resourceType, 
+			String currentFolder, String constructedUrl) {
+	
+		try {
+			DocumentBuilderFactory factory = DocumentBuilderFactory
+					.newInstance();
+			DocumentBuilder builder = factory.newDocumentBuilder();
+			document = builder.newDocument();
+		} catch (ParserConfigurationException e) {
+			throw new RuntimeException(e);
+		}
+	
+		Element root = document.createElement("Connector");
+		document.appendChild(root);
+		root.setAttribute("command", command.toString());
+		root.setAttribute("resourceType", resourceType.getName());
+	
+		Element currentFolderElement = document.createElement("CurrentFolder");
+		currentFolderElement.setAttribute("path", currentFolder);
+	
+		currentFolderElement.setAttribute("url", constructedUrl);
+		root.appendChild(currentFolderElement);
+	
+	}
+
+	/**
+	 * Use this constructor if want to respond a negative/error message only.
+	 * 
+	 * @param number
+	 */
+	public GetResponse(int number) {
+		this(number, null);
+	}
+	
+	/**
+	 * Sets an error number with a custom message.
+	 * 
+	 * @param number
+	 * @param text
+	 */
+	public void setError(int number, String text) {
+
+		if (errorElement == null) {
+			errorElement = document.createElement("Error");
+			document.getDocumentElement().appendChild(errorElement);
+		}
+
+		errorElement.setAttribute("number", String.valueOf(number));
+		if (Utils.isNotEmpty(text))
+			errorElement.setAttribute("text", text);
+
+	}
+
+	/**
+	 * Sets an error number.
+	 * 
+	 * @param number
+	 */
+	public void setError(int number) {
+		setError(number, null);
+	}
+
+	/**
+	 * Lists all folders as XML tags.
+	 * @param dir
+	 */
+	public void setFolders(final List<String> dirs) {
+		if (foldersElement != null) {
+			Element parent = (Element) foldersElement.getParentNode();
+			parent.removeChild(foldersElement);
+		}
+
+		foldersElement = document.createElement("Folders");
+		document.getDocumentElement().appendChild(foldersElement);
+
+		for (String file : dirs) {
+			Element folderElement = document.createElement("Folder");
+			folderElement.setAttribute("name", file);
+			foldersElement.appendChild(folderElement);
+		}
+	}
+	
+	/**
+	 * Lists all files XML tags.
+	 * 
+	 * @param Map, key is the file name and value is the size of the file in bytes
+	 */
+	public void setFiles(final List<Map<String, Object>> files) {
+		if (filesElement != null) {
+			Element parent = (Element) filesElement.getParentNode();
+			parent.removeChild(filesElement);
+		}
+
+		filesElement = document.createElement("Files");
+		document.getDocumentElement().appendChild(filesElement);
+		
+		long length = 1L;
+		long tempLength;
+		
+		for (Map<String, Object> file : files) {
+			Element fileElement = document.createElement("File");
+			fileElement.setAttribute("name", (String) file.get(Connector.KEY_NAME));
+			tempLength = (Long) file.get(Connector.KEY_SIZE);
+			if (tempLength > 1024)
+				length = tempLength/1024;
+			fileElement.setAttribute("size", String.valueOf(length));
+			filesElement.appendChild(fileElement);
+		}
+	}
+	
+	@Override
+	public String toString() {
+		document.getDocumentElement().normalize();
+		TransformerFactory factory = TransformerFactory.newInstance();
+
+		StringWriter sw = new StringWriter();
+
+		try {
+			Transformer transformer = factory.newTransformer();
+
+			DOMSource source = new DOMSource(document);
+			StreamResult result = new StreamResult(sw);
+
+			transformer.transform(source, result);
+		} catch (TransformerException e) {
+			throw new RuntimeException(e);
+		}
+
+		return sw.toString();
+	}
+	
+	public static GetResponse getOK() {
+		return new GetResponse(EN_OK);
+	}
+	
+	public static GetResponse getErrorInvalidFolderName() {
+		return new GetResponse(EN_INVALID_FOLDER_NAME);
+	}
+	
+	public static GetResponse getErrorInvalidCommand() {
+		LocalizedPropertiesLoader lpl = LocalizedPropertiesLoader.getInstance(ThreadLocalData.getServletRequest());
+		return new GetResponse(EN_ERROR, lpl.getInvalidCommand());
+	}
+	
+	public static GetResponse getErrorInvalidType() {
+		LocalizedPropertiesLoader lpl = LocalizedPropertiesLoader.getInstance(ThreadLocalData.getServletRequest());
+		return new GetResponse(EN_ERROR, lpl.getInvalidType());
+	}
+	
+	public static GetResponse getErrorInvalidCurrentFolder() {
+		LocalizedPropertiesLoader lpl = LocalizedPropertiesLoader.getInstance(ThreadLocalData.getServletRequest());
+		return new GetResponse(EN_ERROR, lpl.getInvalidCurrentFolder());
+	}
+	
+	public static GetResponse getErrorFolderAlreadyExists() {
+		return new GetResponse(EN_ALREADY_EXISTS);
+	}
+	
+	public static GetResponse getErrorSecurity() {
+		return new GetResponse(EN_SECURITY_ERROR);
+	}
+	
+	public static GetResponse getErrorFileBrowsingDisabled() {
+		LocalizedPropertiesLoader lpl = LocalizedPropertiesLoader.getInstance(ThreadLocalData.getServletRequest());
+		return new GetResponse(EN_ERROR, lpl.getFileBrowsingDisabled());
+	}
+
+	public static GetResponse getErrorFolderCreationDisabled() {
+		LocalizedPropertiesLoader lpl = LocalizedPropertiesLoader.getInstance(ThreadLocalData.getServletRequest());
+		return new GetResponse(EN_ERROR, lpl.getFolderCreationDisabled());
+	}
+	
+	public static GetResponse getErrorUnknown() {
+		return new GetResponse(EN_UKNOWN);
+	}
+}
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/response/UploadResponse.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/response/UploadResponse.java	(revision 2578)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/response/UploadResponse.java	(revision 2584)
@@ -21,4 +21,6 @@
 package net.fckeditor.response;
 
+import net.fckeditor.handlers.LocalizedPropertiesLoader;
+import net.fckeditor.requestcycle.ThreadLocalData;
 import net.fckeditor.tool.Utils;
 
@@ -38,5 +40,5 @@
  * The UploadResponse constructor behaves the same way by simply calling it
  * with:<br/>
- * <code>UploadResponse ur = new UploadResonse(SC_SOME_ERROR,"/some/url/file.img","file.img","no error"):</code>
+ * <code>UploadResponse ur = new UploadResponse(SC_SOME_ERROR,"/some/url/file.img","file.img","no error"):</code>
  * </p>
  * 
@@ -123,4 +125,32 @@
 		}
 	}
+	
+	public static UploadResponse getErrorSecurity() {
+		return new UploadResponse(SC_SECURITY_ERROR);
+	}
+	
+	public static UploadResponse getErrorInvalidExtension() {
+		return new UploadResponse(SC_INVALID_EXTENSION);
+	}
+	
+	public static UploadResponse getErrorInvalidCommand() {
+		LocalizedPropertiesLoader lpl = LocalizedPropertiesLoader.getInstance(ThreadLocalData.getServletRequest());
+		return new UploadResponse(SC_ERROR, null, null, lpl.getInvalidCommand());
+	}
+	
+	public static UploadResponse getErrorInvalidType() {
+		LocalizedPropertiesLoader lpl = LocalizedPropertiesLoader.getInstance(ThreadLocalData.getServletRequest());
+		return new UploadResponse(SC_ERROR, null, null, lpl.getInvalidType());
+	}
+	
+	public static UploadResponse getErrorInvalidCurrentFolder() {
+		LocalizedPropertiesLoader lpl = LocalizedPropertiesLoader.getInstance(ThreadLocalData.getServletRequest());
+		return new UploadResponse(SC_ERROR, null, null, lpl.getInvalidCurrentFolder());
+	}
+
+	public static UploadResponse getErrorFileUploadDisabled() {
+		LocalizedPropertiesLoader lpl = LocalizedPropertiesLoader.getInstance(ThreadLocalData.getServletRequest());
+		return new UploadResponse(SC_ERROR, null, null, lpl.getFileUploadDisabled());
+	}
 
 	/**
@@ -132,8 +162,6 @@
 		sb.append("<script type=\"text/javascript\">\n");
 		// Compressed version of the document.domain automatic fix script.
-		// The original script can be found at [fckeditor
-		// dir]/_dev/domain_fix_template.js
-		sb
-				.append("(function(){var d=document.domain;while (true){try{var A=window.parent.document.domain;break;}catch(e) {};d=d.replace(/.*?(?:\\.|$)/,'');if (d.length==0) break;try{document.domain=d;}catch (e){break;}}})();\n");
+		// The original script can be found at [fckeditor_dir]/_dev/domain_fix_template.js
+		sb.append("(function(){var d=document.domain;while (true){try{var A=window.parent.document.domain;break;}catch(e) {};d=d.replace(/.*?(?:\\.|$)/,'');if (d.length==0) break;try{document.domain=d;}catch (e){break;}}})();\n");
 		sb.append("window.parent.OnUploadCompleted(");
 
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/tags/CheckTag.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/tags/CheckTag.java	(revision 2578)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/tags/CheckTag.java	(revision 2584)
@@ -82,5 +82,5 @@
 
 		if (command.equals(FILE_UPLOAD)) {
-			if (RequestCycleHandler.isEnabledForFileUpload(request))
+			if (RequestCycleHandler.isEnabledForFileUpload())
 				response = lpl.getFileUploadEnabled();
 			else
@@ -89,5 +89,5 @@
 
 		if (command.equals(FILE_BROWSING)) {
-			if (RequestCycleHandler.isEnabledForFileBrowsing(request))
+			if (RequestCycleHandler.isEnabledForFileBrowsing())
 				response = lpl.getFileBrowsingEnabled();
 			else
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/tool/UtilsFile.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/tool/UtilsFile.java	(revision 2578)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/tool/UtilsFile.java	(revision 2584)
@@ -24,5 +24,5 @@
 import java.io.InputStream;
 
-import javax.servlet.http.HttpServletRequest;
+import net.fckeditor.handlers.ConnectorHandler;
 
 import org.apache.commons.io.FilenameUtils;
@@ -30,8 +30,4 @@
 import org.slf4j.Logger;
 import org.slf4j.LoggerFactory;
-
-import net.fckeditor.handlers.ConnectorHandler;
-import net.fckeditor.handlers.RequestCycleHandler;
-import net.fckeditor.handlers.ResourceTypeHandler;
 
 /**
@@ -149,19 +145,19 @@
 		}
 	}
-	
-	/**
-	 * Compose server-side response path.
-	 * 
-	 * @param request
-	 * @param resourceType
-	 * @return server-side path of <code>resourceType</code>.
-	 */
-	public static String constructServerSidePath(HttpServletRequest request,
-			ResourceTypeHandler resourceType) {
-		StringBuffer sb = new StringBuffer(RequestCycleHandler.getLocalUserFilePath());
-		sb.append(resourceType.getPath());
 
-		return sb.toString();
+	public static File getUniqueFile(final File file) {
+		if (!file.exists())
+			return file;
+		
+		File tmpFile = new File(file.getAbsolutePath());
+		File dir = tmpFile.getParentFile();
+		int count = 1;
+		String extension = FilenameUtils.getExtension(tmpFile.getName());
+		String baseName = FilenameUtils.getBaseName(tmpFile.getName());
+		do {
+			tmpFile = new File(dir, baseName + "(".concat(String.valueOf(count)).concat(").").concat(extension));
+			count++;
+		} while (tmpFile.exists());
+		return tmpFile;
 	}
-
 }
